/*
	Preparation Date : 2014-09-24
	Preparation By   : Rahmat
	Description      : Update price
*/

CREATE PROCEDURE [dbo].[SP_DLV_UPDATE_PRICE]
@ROUTE_CD VARCHAR(4),
@LP_CD VARCHAR(50),
@PRICE INT,
@DATEFROM VARCHAR(20),
@DATETO VARCHAR(20),
@USER VARCHAR(50),
@PRICE_TYPE char(1)
AS
BEGIN

--CHECK USER
DECLARE @CHECK_AUTH INT;
SET @CHECK_AUTH = (SELECT COUNT (*) FROM TB_R_VW_EMPLOYEE WHERE JOB_FUNCTION_ID = 11 AND USERNAME = @USER);
IF (@CHECK_AUTH=1)BEGIN
		
	IF EXISTS (SELECT 1 FROM TB_M_ROUTE_PRICE WHERE ROUTE_CD = @ROUTE_CD AND LP_CD = @LP_CD AND VALID_FROM = @DATETO AND VALID_TO = '9999-12-31')
		BEGIN
				IF EXISTS (SELECT 1 FROM TB_M_ROUTE_PRICE WHERE ROUTE_CD = @ROUTE_CD AND LP_CD = @LP_CD and @DATEFROM BETWEEN VALID_FROM AND VALID_TO AND VALID_TO = '9999-12-31')
				BEGIN
				BEGIN TRAN
		
		PRINT 'Saya Melakukan Insert Ke H Route Price Dengan Route : ' + @ROUTE_CD 		
			 INSERT INTO TB_H_ROUTE_PRICE ([ROUTE_CD],[LP_CD],[PRICE],[VALID_FROM],[VALID_TO],[PRICE_TYPE],[CREATED_BY],[CREATED_DT],[CHANGED_BY],[CHANGED_DT],[OPERATION],[OPERATION_BY],[OPERATION_DT])
							
			(SELECT [ROUTE_CD],[LP_CD],[PRICE],[VALID_FROM],[VALID_TO],[PRICE_TYPE],[CREATED_BY],[CREATED_DT],[CHANGED_BY],[CHANGED_DT],'Edit',@USER,GETDATE() 
			 FROM TB_M_ROUTE_PRICE WHERE ROUTE_CD = @ROUTE_CD AND LP_CD = @LP_CD AND VALID_TO = '9999-12-31')
			
			PRINT 'Saya Melakukan Update Ke TB M Price Dengan Route : ' + @ROUTE_CD

			UPDATE TB_M_ROUTE_PRICE SET PRICE = @PRICE,CHANGED_BY = @USER ,CHANGED_DT = GETDATE()
			WHERE ROUTE_CD = CAST(@ROUTE_CD AS VARCHAR(MAX)) AND LP_CD = @LP_CD  AND VALID_FROM = @DATETO AND VALID_TO = '9999-12-31'
					
					--CHECK AND EDIT  ROUTE PRICE PARENT
					--CURSOR
					DECLARE @ROUTE_CD_CHILD VARCHAR(50),@CHILD_LP_CD VARCHAR(50),@VALID_FROM VARCHAR(50);
					DECLARE C_DRAFT_ROUTE CURSOR FOR
					SELECT ROUTE_CD_CHILD,LP_CD,VALID_FROM FROM TB_M_DLV_DRAFT_ROUTE_PRICE WHERE ROUTE_CD_PARENT = @ROUTE_CD AND VALID_TO = '9999-12-31'
					OPEN C_DRAFT_ROUTE
					
					FETCH NEXT FROM C_DRAFT_ROUTE INTO @ROUTE_CD_CHILD,@CHILD_LP_CD,@VALID_FROM
					WHILE @@FETCH_STATUS = 0
					BEGIN

					--INSERT TB_H_ROUTE_PRICE
							INSERT INTO TB_H_ROUTE_PRICE ([ROUTE_CD],[LP_CD],[PRICE],[VALID_FROM],[VALID_TO],[PRICE_TYPE],[CREATED_BY],[CREATED_DT],[CHANGED_BY],[CHANGED_DT],[OPERATION],[OPERATION_BY],[OPERATION_DT])
							(SELECT [ROUTE_CD],[LP_CD],[PRICE],[VALID_FROM],[VALID_TO],[PRICE_TYPE],[CREATED_BY],[CREATED_DT],[CHANGED_BY],[CHANGED_DT],'Edit',@USER,GETDATE() 
							FROM TB_M_ROUTE_PRICE WHERE ROUTE_CD = @ROUTE_CD_CHILD AND LP_CD = @CHILD_LP_CD AND VALID_TO = '9999-12-31')
							
					 --UPDATE TB M ROUTE
					UPDATE TB_M_ROUTE_PRICE SET PRICE = @PRICE ,CHANGED_BY = @USER ,CHANGED_DT = GETDATE()
					WHERE ROUTE_CD = CAST(@ROUTE_CD_CHILD AS VARCHAR(MAX)) AND LP_CD = @CHILD_LP_CD AND VALID_TO = '9999-12-31'
						
						
					FETCH NEXT FROM C_DRAFT_ROUTE INTO @ROUTE_CD_CHILD,@CHILD_LP_CD,@VALID_FROM
					END
					CLOSE C_DRAFT_ROUTE
					DEALLOCATE C_DRAFT_ROUTE
					
					COMMIT

					--CURSOR
					
				END
				ELSE BEGIN
				SELECT 3
				END
					
		SELECT 1
		END
	ELSE
		BEGIN
			--"No Edit"
		SELECT 2
	END
	
END
	ELSE BEGIN
	SELECT 4
END
	
END

